// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library passive_data.test.utils_test;

import 'package:test/test.dart';
import 'package:passive_data/passive_data.dart';

void main() {
  test('Test generatePsdCode()', () {
    expect(generatePsdCode('String', 'data'), equals('data'));
    expect(generatePsdCode('List<Point>', 'data'), equals('toPdsList(data)'));
    expect(generatePsdCode('Set<Point>', 'data'), equals('toPdsSet(data)'));
    expect(generatePsdCode('Map<int,Point>', 'data'), equals('toPdsMap(data)'));
    expect(generatePsdCode('Point', 'data'), equals('data.toPds()'));
  });

  test('Test generateDataFromPdsCode()', () {
    expect(generateCodeFromPsd('dynamic', 'value'), equals('value'));
    expect(generateCodeFromPsd('String', 'value'), equals('value as String'));
    expect(generateCodeFromPsd('Map<String, Map<int, dynamic>>', 'value'),
        equals('value as Map<String,Map<int,dynamic>>'));
    expect(
        generateCodeFromPsd('List<Set<MyObject>>', 'value', 'List<Set<int>>'),
        equals('''
new List<Set<MyObject>>.generate(value.length,
 (int i1) => new List<MyObject>.generate(value[i1].length,
 (int i2) => new MyObject.fromPds(value[i1][i2] as int)).toSet())'''
            .replaceAll('\n', '')));
    expect(
        generateCodeFromPsd(
            'List<Set<MyObject>>', 'value', 'List<Set<dynamic>>'),
        equals('''
new List<Set<MyObject>>.generate(value.length,
 (int i1) => new List<MyObject>.generate(value[i1].length,
 (int i2) => new MyObject.fromPds(value[i1][i2])).toSet())'''
            .replaceAll('\n', '')));
  });
}
